// Generated by CoffeeScript 1.12.7
(function() {
  var Unique_ID, debug, default_eavesdrop_timeout, hand, heal, pkg, ref, seem;

  seem = require('seem');

  pkg = require('../../../package.json');

  this.name = pkg.name + ":middleware:client:egress:centrex-redirect";

  ref = (require('tangible'))(this.name), debug = ref.debug, hand = ref.hand, heal = ref.heal;

  Unique_ID = 'Unique-ID';

  default_eavesdrop_timeout = 8 * 3600;

  this.include = seem(function*() {
    var eavesdrop_key, eavesdrop_timeout, is_remote, key, monitor, queuer, ref1, res, server, uri;
    if (this.session.direction !== 'egress') {
      return;
    }
    if (this.session.dialplan !== 'centrex') {
      return;
    }
    is_remote = (yield this.cfg.is_remote(this.session.number_domain, [this.session.local_server, this.session.client_server].join('/')));
    if (is_remote) {
      server = is_remote.split('/')[1];
      this.report({
        state: 'centrex-redirect',
        server: server
      });
      uri = "<sip:" + this.destination + "@" + server + ";xref=" + this.session.reference + ">";
      this.debug('Handling is remote', uri);
      if (this.data['Answer-State'] === 'answered') {
        uri = "<sip:" + this.destination + "@" + this.session.number_domain + ";xref=" + this.session.reference + "?Via=" + server + ">";
        res = (yield this.action('deflect', uri));
      } else {
        res = (yield this.action('redirect', uri));
      }
      this.debug('Redirection returned', uri, res);
      this.direction('transferred');
      return;
    }
    this.debug('Handling is local');
    eavesdrop_timeout = this.cfg.eavesdrop_timeout;
    if (eavesdrop_timeout == null) {
      eavesdrop_timeout = default_eavesdrop_timeout;
    }
    key = this.source + "@" + this.session.number_domain;
    eavesdrop_key = "outbound:" + key;
    queuer = this.cfg.queuer;
    if (!(this.session.transfer || this.call.closed)) {
      this.debug('Set outbound eavesdrop', eavesdrop_key);
      yield ((ref1 = this.local_redis) != null ? ref1.setex(eavesdrop_key, eavesdrop_timeout, this.call.uuid) : void 0);
      debug('CHANNEL_PRESENT', key, this.call.uuid);
      yield (queuer != null ? queuer.track(key, this.call.uuid) : void 0);
      yield (queuer != null ? queuer.on_present(this.call.uuid) : void 0);
      this.report({
        event: 'start-of-call',
        agent: key,
        call: this.call.uuid
      });
      monitor = (yield this.cfg.api.monitor(this.call.uuid, ['CHANNEL_BRIDGE', 'CHANNEL_UNBRIDGE', 'CHANNEL_HANGUP_COMPLETE']));
      monitor.on('CHANNEL_BRIDGE', hand((function(_this) {
        return function*(arg) {
          var a_uuid, b_uuid, body;
          body = arg.body;
          a_uuid = body['Bridge-A-Unique-ID'];
          b_uuid = body['Bridge-B-Unique-ID'];
          debug('CHANNEL_BRIDGE', key, a_uuid, b_uuid);
          yield (queuer != null ? queuer.track(key, a_uuid) : void 0);
          yield (queuer != null ? queuer.on_bridge(a_uuid) : void 0);
        };
      })(this)));
      monitor.on('CHANNEL_UNBRIDGE', hand((function(_this) {
        return function*(arg) {
          var a_uuid, b_uuid, body, disposition, ref2, ref3;
          body = arg.body;
          a_uuid = body['Bridge-A-Unique-ID'];
          b_uuid = body['Bridge-B-Unique-ID'];
          disposition = body != null ? body.variable_transfer_disposition : void 0;
          debug('CHANNEL_UNBRIDGE', key, a_uuid, b_uuid, disposition, body.variable_endpoint_disposition);
          if (disposition === 'replaced') {
            yield (queuer != null ? queuer.track(key, b_uuid) : void 0);
            yield ((ref2 = _this.local_redis) != null ? ref2.setex(eavesdrop_key, eavesdrop_timeout, b_uuid) : void 0);
          } else {
            yield ((ref3 = _this.local_redis) != null ? ref3.del(eavesdrop_key) : void 0);
          }
          yield (queuer != null ? queuer.on_unbridge(a_uuid) : void 0);
          yield (queuer != null ? queuer.untrack(key, a_uuid) : void 0);
          _this.report({
            event: 'end-of-call',
            agent: key
          });
        };
      })(this)));
      monitor.once('CHANNEL_HANGUP_COMPLETE', hand((function(_this) {
        return function*(arg) {
          var a_uuid, body, disposition, ref2;
          body = arg.body;
          yield (monitor != null ? monitor.end() : void 0);
          monitor = null;
          a_uuid = body[Unique_ID];
          disposition = body != null ? body.variable_transfer_disposition : void 0;
          debug('CHANNEL_HANGUP_COMPLETE', key, a_uuid, disposition, body.variable_endpoint_disposition);
          if (disposition !== 'recv_replace') {
            yield ((ref2 = _this.local_redis) != null ? ref2.del(eavesdrop_key) : void 0);
            yield (queuer != null ? queuer.on_unbridge(a_uuid) : void 0);
            yield (queuer != null ? queuer.untrack(key, a_uuid) : void 0);
            _this.report({
              event: 'end-of-call',
              agent: key,
              call: a_uuid
            });
          }
        };
      })(this)));
    }
    return this.debug('Ready');
  });

}).call(this);
