// Generated by CoffeeScript 1.12.7
(function() {
  var debug, pkg, seem;

  seem = require('seem');

  pkg = require('../../../package.json');

  this.name = pkg.name + ":middleware:client:egress:pre";

  debug = (require('tangible'))(this.name);

  this.include = seem(function*() {
    var base, base1, base2, base3, base4, base5, base6, base7, location, music_uri, number_domain, privacy, ref, ref1, ref2, src_number;
    if (this.session.direction !== 'egress') {
      return;
    }
    music_uri = (function(_this) {
      return function(doc) {
        if (doc.music == null) {
          return null;
        }
        return _this.prompt.uri('prov', 'prov', doc._id, doc.music);
      };
    })(this);
    this.session.endpoint_name = this.req.header('X-En');
    if ((base = this.session).endpoint_name == null) {
      base.endpoint_name = (yield this.reference.get_endpoint());
    }
    if (this.session.endpoint_name == null) {
      this.debug.dev('Missing endpoint_name', this.call.data);
      return this.respond('485 Missing Endpoint Header');
    }
    this.debug('endpoint', this.session.endpoint_name);
    yield this.reference.set_endpoint(this.session.endpoint_name);
    yield this.unset('sip_h_X-En');
    this.session.endpoint = (yield this.cfg.prov.get("endpoint:" + this.session.endpoint_name));
    yield this.reference.add_in(this.session.endpoint._id);
    if (this.session.endpoint.timezone != null) {
      this.session.timezone = this.session.endpoint.timezone;
    }
    if (this.session.endpoint.music != null) {
      this.session.music = music_uri(this.session.endpoint);
    }
    if (this.session.endpoint.trace) {
      this.session.dev_logger = true;
    }
    this.session.agent = this.session.endpoint_name;
    this.session.agent_name = (ref = this.session.endpoint.display_name) != null ? ref : this.source;
    this.set({
      ccnq_endpoint: this.session.endpoint_name,
      ccnq_endpoint_json: JSON.stringify(this.session.endpoint)
    });
    this.session.outbound_route = this.session.endpoint.outbound_route;
    if (this.session.outbound_route == null) {
      this.debug.dev('Missing outbound_route', this.session.endpoint);
      return this.respond('500 Endpoint has no outbound_route');
    }
    this.debug('outbound_route', this.session.outbound_route);
    number_domain = this.session.endpoint.number_domain;
    if (number_domain == null) {
      this.debug.dev('Missing number_domain', this.session.endpoint);
      return this.respond('480 Missing Number Domain');
    }
    this.session.number_domain = number_domain;
    this.session.number_domain_data = (yield this.cfg.prov.get("number_domain:" + number_domain)["catch"]((function(_this) {
      return function(error) {
        _this.debug("number_domain " + number_domain + ": " + error);
        return {};
      };
    })(this)));
    this.debug('number_domain', number_domain);
    yield this.reference.add_in(this.session.number_domain_data._id);
    yield this.user_tags(this.session.number_domain_data.tags);
    if (this.session.number_domain_data.timezone != null) {
      if ((base1 = this.session).timezone == null) {
        base1.timezone = this.session.number_domain_data.timezone;
      }
    }
    if (this.session.number_domain_data.music != null) {
      if ((base2 = this.session).music == null) {
        base2.music = music_uri(this.session.number_domain_data);
      }
    }
    src_number = this.source + "@" + number_domain;
    if (this.session.transfer) {
      this.session.number = {};
    } else {
      this.session.number = (yield this.cfg.prov.get("number:" + src_number)["catch"]((function(_this) {
        return function(error) {
          _this.debug.ops("number:" + src_number + ": " + error);
          return {};
        };
      })(this)));
    }
    if (this.session.number._id != null) {
      yield this.reference.add_in(this.session.number._id);
    }
    if (this.session.number.timezone != null) {
      this.session.timezone = this.session.number.timezone;
    }
    if (this.session.number.music != null) {
      this.session.music = music_uri(this.session.number);
    }
    if (this.session.number.trace) {
      this.session.dev_logger = true;
    }
    if (this.session.number.record_egress) {
      this.record_call(this.session.number._id);
    }
    this.session.dialplan = this.session.number.dialplan;
    if ((base3 = this.session).dialplan == null) {
      base3.dialplan = this.session.endpoint.dialplan;
    }
    if ((base4 = this.session).dialplan == null) {
      base4.dialplan = this.session.number_domain_data.dialplan;
    }
    this.session.country = this.session.number.country;
    if ((base5 = this.session).country == null) {
      base5.country = this.session.endpoint.country;
    }
    if ((base6 = this.session).country == null) {
      base6.country = this.session.number_domain_data.country;
    }
    if (this.session.country != null) {
      this.session.country = this.session.country.toLowerCase();
    }
    this.debug('Ready', {
      endpoint_name: this.session.endpoint_name,
      outbound_route: this.session.outbound_route,
      number_domain: this.session.number_domain,
      dialplan: this.session.dialplan,
      country: this.session.country
    });
    location = this.session.number.location;
    if (location == null) {
      location = this.session.endpoint.location;
    }
    if (location == null) {
      location = '';
    }
    this.session.emergency_location = location;
    privacy = this.session.number.privacy;
    if (privacy == null) {
      privacy = this.session.endpoint.privacy;
    }
    if (privacy) {
      yield this.action('privacy', 'number');
    } else {
      yield this.action('privacy', 'no');
    }
    this.session.asserted = this.session.number.asserted_number;
    if ((base7 = this.session).asserted == null) {
      base7.asserted = this.session.endpoint.asserted_number;
    }
    if (this.session.endpoint.check_from) {
      if (this.session.number.endpoint !== this.session.endpoint_name) {
        this.debug('From Username is not listed');
        return this.respond('403 From Username is not listed');
      }
    }
    yield this.set({
      ignore_sdp_ice: (ref1 = this.session.endpoint.ignore_sdp_ice) != null ? ref1 : true
    });
    this.report({
      state: 'egress-received',
      endpoint: this.session.endpoint._id,
      number_domain: this.session.number_domain_data._id,
      number: (ref2 = this.session.number._id) != null ? ref2 : null
    });
    this.debug('OK');
  });

}).call(this);
