// Generated by CoffeeScript 1.12.7
(function() {
  var Solid, Unique_ID, debug, default_eavesdrop_timeout, default_intercept_timeout, hand, make_id, pkg, ref, seem, send;

  seem = require('seem');

  pkg = require('../../../package.json');

  this.name = pkg.name + ":middleware:client:ingress:send";

  ref = (require('tangible'))(this.name), debug = ref.debug, hand = ref.hand;

  Solid = require('solid-gun');

  Unique_ID = 'Unique-ID';

  make_id = function() {
    return Solid.time() + Solid.uniqueness();
  };

  default_eavesdrop_timeout = 8 * 3600;

  default_intercept_timeout = 8 * 3600;

  this.include = function() {
    var ref1;
    if (this.session.direction !== 'ingress') {
      return;
    }
    this.debug('Ready');
    if (((ref1 = this.session.initial_destinations) != null ? ref1.length : void 0) > 0) {
      return send.call(this, this.session.initial_destinations);
    }
  };

  this.send = send = seem(function*(destinations) {
    var base, cause, code, data, eavesdrop_key, eavesdrop_timeout, intercept_key, intercept_timeout, key, monitor, monitor_far, new_uuid, queuer, ref1, ref2, ref3, ref4, ref5, ref6, res, sofia;
    new_uuid = make_id();
    ref1 = this.cfg, eavesdrop_timeout = ref1.eavesdrop_timeout, intercept_timeout = ref1.intercept_timeout;
    if (eavesdrop_timeout == null) {
      eavesdrop_timeout = default_eavesdrop_timeout;
    }
    if (intercept_timeout == null) {
      intercept_timeout = default_intercept_timeout;
    }
    key = this.destination + "@" + this.session.number_domain;
    intercept_key = "inbound_call:" + key;
    yield ((ref2 = this.local_redis) != null ? ref2.setex(intercept_key, intercept_timeout, new_uuid) : void 0);
    this.session.agent = key;
    eavesdrop_key = "inbound:" + key;
    queuer = this.cfg.queuer;
    if (!(this.call.closed || this.session.dialplan !== 'centrex')) {
      this.debug('Set inbound eavesdrop', eavesdrop_key);
      yield ((ref3 = this.local_redis) != null ? ref3.setex(eavesdrop_key, eavesdrop_timeout, new_uuid) : void 0);
      debug('CHANNEL_PRESENT', key, new_uuid);
      yield (queuer != null ? queuer.track(key, new_uuid) : void 0);
      yield (queuer != null ? queuer.on_present(new_uuid) : void 0);
      this.report({
        event: 'start-of-call',
        agent: key,
        call: new_uuid
      });
      monitor_far = (yield this.cfg.api.monitor(this.call.uuid, ['CHANNEL_BRIDGE', 'CHANNEL_UNBRIDGE', 'CHANNEL_HANGUP_COMPLETE']));
      monitor_far.on('CHANNEL_BRIDGE', hand((function(_this) {
        return function*(arg) {
          var a_uuid, b_uuid, body;
          body = arg.body;
          a_uuid = body['Bridge-A-Unique-ID'];
          b_uuid = body['Bridge-B-Unique-ID'];
          debug('CHANNEL_BRIDGE (far)', key, a_uuid, b_uuid);
          if (b_uuid !== new_uuid) {
            return;
          }
          yield (queuer != null ? queuer.track(key, b_uuid) : void 0);
          yield (queuer != null ? queuer.on_bridge(b_uuid) : void 0);
        };
      })(this)));
      monitor_far.on('CHANNEL_UNBRIDGE', hand((function(_this) {
        return function*(arg) {
          var a_uuid, b_uuid, body;
          body = arg.body;
          a_uuid = body['Bridge-A-Unique-ID'];
          b_uuid = body['Bridge-B-Unique-ID'];
          debug('CHANNEL_UNBRIDGE (far)', key, a_uuid, b_uuid);
          if (b_uuid !== new_uuid) {
            return;
          }
          yield (queuer != null ? queuer.on_unbridge(b_uuid) : void 0);
          yield (queuer != null ? queuer.untrack(key, b_uuid) : void 0);
        };
      })(this)));
      monitor_far.on('CHANNEL_HANGUP_COMPLETE', hand((function(_this) {
        return function*(arg) {
          var body, monitor;
          body = arg.body;
          yield (typeof monitor !== "undefined" && monitor !== null ? monitor.end() : void 0);
          return monitor = null;
        };
      })(this)));
      monitor = (yield this.cfg.api.monitor(new_uuid, ['CHANNEL_BRIDGE', 'CHANNEL_UNBRIDGE', 'CHANNEL_HANGUP_COMPLETE']));
      monitor.on('CHANNEL_BRIDGE', hand((function(_this) {
        return function*(arg) {
          var a_uuid, b_uuid, body;
          body = arg.body;
          a_uuid = body['Bridge-A-Unique-ID'];
          b_uuid = body['Bridge-B-Unique-ID'];
          debug('CHANNEL_BRIDGE', key, a_uuid, b_uuid);
          yield (queuer != null ? queuer.track(key, a_uuid) : void 0);
          yield (queuer != null ? queuer.on_bridge(a_uuid) : void 0);
        };
      })(this)));
      monitor.on('CHANNEL_UNBRIDGE', hand((function(_this) {
        return function*(arg) {
          var a_uuid, b_uuid, body, disposition, ref4, ref5;
          body = arg.body;
          a_uuid = body['Bridge-A-Unique-ID'];
          b_uuid = body['Bridge-B-Unique-ID'];
          disposition = body != null ? body.variable_transfer_disposition : void 0;
          debug('CHANNEL_UNBRIDGE', key, a_uuid, b_uuid, disposition, body.variable_endpoint_disposition);
          if (disposition === 'replaced') {
            yield (queuer != null ? queuer.track(key, b_uuid) : void 0);
            yield ((ref4 = _this.local_redis) != null ? ref4.setex(eavesdrop_key, eavesdrop_timeout, b_uuid) : void 0);
          } else {
            yield ((ref5 = _this.local_redis) != null ? ref5.del(eavesdrop_key) : void 0);
          }
          yield (queuer != null ? queuer.on_unbridge(a_uuid) : void 0);
          yield (queuer != null ? queuer.untrack(key, a_uuid) : void 0);
          _this.report({
            event: 'end-of-call',
            agent: key
          });
        };
      })(this)));
      monitor.once('CHANNEL_HANGUP_COMPLETE', hand((function(_this) {
        return function*(arg) {
          var a_uuid, body, disposition, ref4;
          body = arg.body;
          yield (monitor != null ? monitor.end() : void 0);
          monitor = null;
          a_uuid = body[Unique_ID];
          disposition = body != null ? body.variable_transfer_disposition : void 0;
          debug('CHANNEL_HANGUP_COMPLETE', key, a_uuid, disposition, body.variable_endpoint_disposition);
          if (disposition !== 'replaced') {
            yield ((ref4 = _this.local_redis) != null ? ref4.del(eavesdrop_key) : void 0);
            yield (queuer != null ? queuer.on_unbridge(a_uuid) : void 0);
            yield (queuer != null ? queuer.untrack(key, a_uuid) : void 0);
            _this.report({
              event: 'end-of-call',
              agent: key,
              call: a_uuid
            });
          }
        };
      })(this)));
    }
    sofia = destinations.map((function(_this) {
      return function(arg, index) {
        var parameters, ref4, to_uri;
        parameters = (ref4 = arg.parameters) != null ? ref4 : [], to_uri = arg.to_uri;
        if (index === 0) {
          return "[origination_uuid=" + new_uuid + "," + (parameters.join(',')) + "]sofia/" + _this.session.sip_profile + "/" + to_uri;
        } else {
          return "[" + (parameters.join(',')) + "]sofia/" + _this.session.sip_profile + "/" + to_uri;
        }
      };
    })(this));
    this.debug('send', sofia);
    yield this.set({
      continue_on_fail: true
    });
    this.debug('Bridging', sofia);
    this.report({
      state: 'ingress-bridging'
    });
    res = (yield this.action('bridge', sofia.join(',')));
    yield ((ref4 = this.local_redis) != null ? ref4.del(intercept_key) : void 0);
    data = res.body;
    if ((base = this.session).bridge_data == null) {
      base.bridge_data = [];
    }
    this.session.bridge_data.push(data);
    cause = data != null ? data.variable_last_bridge_hangup_cause : void 0;
    if (cause == null) {
      cause = data != null ? data.variable_originate_disposition : void 0;
    }
    code = data != null ? (ref5 = data.variable_last_bridge_proto_specific_hangup_cause) != null ? (ref6 = ref5.match(/^sip:(\d+)$/)) != null ? ref6[1] : void 0 : void 0 : void 0;
    if (code == null) {
      code = data != null ? data.variable_sip_term_status : void 0;
    }
    this.debug('Outcome', {
      cause: cause,
      code: code
    });
    this.session.was_connected = cause === 'NORMAL_CALL_CLEARING' || cause === 'NORMAL_CLEARING' || cause === 'SUCCESS';
    this.session.was_transferred = (data.variable_transfer_history != null) || data.variable_endpoint_disposition === 'BLIND_TRANSFER' || data.variable_endpoint_disposition === 'ATTENDED_TRANSFER';
    this.session.was_picked = cause === 'PICKED_OFF';
    if (this.session.was_connected) {
      this.debug("Successful call when routing " + this.destination + " through " + (sofia.join(',')));
      this.notify({
        state: 'answered'
      });
      return;
    }
    if (this.session.was_transferred) {
      this.debug("Transferred call when routing " + this.destination + " through " + (sofia.join(',')));
      this.notify({
        state: 'transferred'
      });
      return;
    }
    this.notify({
      event: 'missed'
    });
    if (this.session.was_picked) {
      this.debug("Picked call when routing " + this.destination + " through " + (sofia.join(',')));
      this.notify({
        state: 'picked',
        from_agent: key
      });
      return;
    }
    if (code === '604') {
      yield this.debug.csr('not-registered', {
        destination: this.destination,
        enpoint: this.session.endpoint_name,
        tried_cfnr: this.session.tried_cfnr
      });
    }
    if (code === '604' && !this.session.tried_cfnr) {
      this.report({
        state: 'not-registered'
      });
      this.session.reason = 'unavailable';
      if (this.session.cfnr_voicemail) {
        this.debug('cfnr:voicemail');
        this.destination = this.session.cfnr_voicemail_number;
        this.direction('voicemail');
        return;
      }
      if (this.session.cfnr_number != null) {
        this.debug('cfnr:forward');
        this.session.destination = this.session.cfnr_number;
        this.direction('forward');
        return;
      }
      if (this.session.cfnr != null) {
        this.debug('cfnr:fallback');
        this.session.tried_cfnr = true;
        return send.call(this, [
          {
            to_uri: this.session.cfnr
          }
        ]);
      }
    }
    if (code === '604') {
      if (this.session.fallback_destinations == null) {
        this.debug('cfnr: no fallback');
        return this.respond('500 No Fallback');
      }
      if (this.session.tried_fallback) {
        this.debug('cfnr: already attempted fallback');
        return this.respond('500 Fallback Failed');
      }
      this.debug('cfnr: fallback on 604');
      this.session.tried_fallback = true;
      return send.call(this, this.session.fallback_destinations);
    }
    if (code === '486' && !this.session.tried_cfb) {
      this.report({
        state: 'user-busy'
      });
      this.session.reason = 'user-busy';
      if (this.session.cfb_voicemail) {
        this.debug('cfb: voicemail');
        this.destination = this.session.cfb_voicemail_number;
        this.direction('voicemail');
        return;
      }
      if (this.session.cfb_number != null) {
        this.debug('cfb:number');
        this.session.destination = this.session.cfb_number;
        this.direction('forward');
        return;
      }
      if (this.session.cfb != null) {
        this.debug('cfb: fallback');
        this.session.tried_cfb = true;
        return send.call(this, [
          {
            to_uri: this.session.cfb
          }
        ]);
      }
    }
    this.debug("Call failed: " + cause + "/" + code + " when routing " + this.destination + " through " + (sofia.join(',')));
    if (!this.session.tried_cfda) {
      this.report({
        state: 'no-answer'
      });
      this.session.reason = 'no-answer';
      if (this.session.cfda_voicemail) {
        this.debug('cfda: voicemail');
        this.destination = this.session.cfda_voicemail_number;
        this.notify({
          state: 'forward-no-answer-to-voicemail'
        });
        this.direction('voicemail');
        return;
      }
      if (this.session.cfda_number != null) {
        this.debug('cfda:number');
        this.session.destination = this.session.cfda_number;
        this.notify({
          state: 'forward-no-answer-to-number'
        });
        this.direction('forward');
        return;
      }
      if (this.session.cfda != null) {
        this.debug('cfda: fallback');
        this.session.tried_cfda = true;
        this.notify({
          state: 'forward-no-answer'
        });
        return send.call(this, [
          {
            to_uri: this.session.cfda
          }
        ]);
      }
    }
    this.debug('Call Failed');
    this.session.call_failed = true;
    this.notify({
      state: 'failed'
    });
  });

}).call(this);
